﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    internal class PlaneCompareByColor : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if (x == null && y == null)
            {
                return 0;
            }

            if (x == null && y != null)
            {
                return 1;
            }

            if (x != null && y != null)
            {
                return -1;
            }

            var xPlane = x as DrawningObjectPlane;
            var yPlane = y as DrawningObjectPlane;

            if (xPlane == null && yPlane == null)
            {
                return 0;
            }

            if (xPlane == null && yPlane != null)
            {
                return 1;
            }

            if (xPlane != null && yPlane == null)
            {
                return 1;
            }

            var xEntity = xPlane.GetPlane.Airbus;
            var yEntity = yPlane.GetPlane.Airbus;
            var colorCompare = xEntity.CorpusColor.Name.CompareTo(yEntity.CorpusColor.Name);

            if (colorCompare != 0 || xEntity is not EntitySuperAirbus xEntityAirbus || yEntity is not EntitySuperAirbus yEntityAirbus)
            {
                return colorCompare;
            }

            return xEntityAirbus.AddColor.Name.CompareTo(yEntityAirbus.AddColor.Name);
        }
    }
}
