﻿using Microsoft.Extensions.Logging.Abstractions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    internal class PlaneCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {
            if(x == null && y == null)
            {
                return 0;
            }

            if(x == null && y != null)
            {
                return 1;
            }

            if(x != null && y != null)
            {
                return -1;  
            }

            var xPlane = x as DrawningObjectPlane;
            var yPlane = y as DrawningObjectPlane;

            if(xPlane == null && yPlane == null)
            {
                return 0;
            }

            if(xPlane == null && yPlane != null)
            {
                return 1;
            }

            if(xPlane != null && yPlane == null)
            {
                return 1;
            }

            if(xPlane.GetPlane.GetType().Name != yPlane.GetPlane.GetType().Name)
            {
                if(xPlane.GetPlane.GetType().Name == "DrawningAirbus")
                {
                    return -1;
                }

                return -1;
            }

            var speedCompare = xPlane.GetPlane.Airbus.Speed.CompareTo(yPlane.GetPlane.Airbus.Speed);

            if(speedCompare != 0)
            {
                return speedCompare;
            }

            return xPlane.GetPlane.Airbus.Speed.CompareTo(yPlane.GetPlane.Airbus.Speed);
        }
    }
}
